ON_BrepEdge Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_brep.h>`

Inheritance diagram for ON_BrepEdge:

## Public Member Functions

ON_BOOL32 | IsClosed () const
| ON_BrepEdge ()
| ON_BrepEdge (int)
ON_BrepEdge & | operator= (const ON_BrepEdge &)
ON::object_type | ObjectType () const
ON_Brep * | Brep () const
ON_BrepTrim * | Trim (int eti) const
int | TrimCount () const
ON_BrepVertex * | Vertex (int evi) const
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON_COMPONENT_INDEX | ComponentIndex () const
ON_BOOL32 | Reverse ()
ON_BOOL32 | SetStartPoint (ON_3dPoint start_point)
ON_BOOL32 | SetEndPoint (ON_3dPoint end_point)
int | EdgeCurveIndexOf () const
const ON_Curve * | EdgeCurveOf () const
bool | ChangeEdgeCurve (int c3i)
void | UnsetPlineEdgeParameters ()
Public Member Functions inherited from ON_CurveProxy
void | DestroyRuntimeCache (bool bDelete=true)
| ON_CurveProxy ()
| ON_CurveProxy (const ON_CurveProxy &)
| ON_CurveProxy (const ON_Curve *)
| ON_CurveProxy (const ON_Curve *, ON_Interval)
ON_CurveProxy & | operator= (const ON_CurveProxy &)
virtual | ~ON_CurveProxy ()
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
void | SetProxyCurve (const ON_Curve *real_curve)
void | SetProxyCurve (const ON_Curve *real_curve, ON_Interval real_curve_subdomain)
const ON_Curve * | ProxyCurve () const
bool | SetProxyCurveDomain (ON_Interval proxy_curve_subdomain)
ON_Interval | ProxyCurveDomain () const
bool | ProxyCurveIsReversed () const
double | RealCurveParameter (double t) const
double | ThisCurveParameter (double real_curve_parameter) const
ON_Curve * | DuplicateCurve () const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
ON_Interval | Domain () const
ON_BOOL32 | SetDomain (double t0, double t1)
bool | SetDomain (ON_Interval domain)
int | SpanCount () const
ON_BOOL32 | GetSpanVector (double *) const
int | Degree () const
ON_BOOL32 | GetParameterTolerance (double, double *, double *) const
ON_BOOL32 | IsLinear (double=ON_ZERO_TOLERANCE) const
int | IsPolyline (ON_SimpleArray< ON_3dPoint > *pline_points=NULL, ON_SimpleArray< double > *pline_t=NULL) const
ON_BOOL32 | IsArc (const ON_Plane *=NULL, ON_Arc *=NULL, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsPlanar (ON_Plane *=NULL, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsInPlane (const ON_Plane &, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsClosed (void) const
ON_BOOL32 | IsPeriodic (void) const
bool | GetNextDiscontinuity (ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
bool | IsContinuous (ON::continuity c, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_BOOL32 | Reverse ()
ON_BOOL32 | Evaluate (double, int, int, double *, int=0, int *=0) const
ON_BOOL32 | Trim (const ON_Interval &domain)
ON_BOOL32 | Split (double t, ON_Curve *&left_side, ON_Curve *&right_side) const
int | GetNurbForm (ON_NurbsCurve &, double=0.0, const ON_Interval *=NULL) const
int | HasNurbForm () const
ON_BOOL32 | GetCurveParameterFromNurbFormParameter (double, double *) const
ON_BOOL32 | GetNurbFormParameterFromCurveParameter (double, double *) const
Public Member Functions inherited from ON_Curve
| ON_Curve ()
| ON_Curve (const ON_Curve &)
ON_Curve & | operator= (const ON_Curve &)
virtual | ~ON_Curve ()
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
ON::object_type | ObjectType () const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | GetDomain (double *t0, double *t1) const
bool | SetDomain (ON_Interval domain)
virtual ON_BOOL32 | ChangeClosedCurveSeam (double t)
virtual bool | ChangeDimension (int desired_dimension)
virtual ON_BOOL32 | GetSpanVectorIndex (double t, int side, int *span_vector_index, ON_Interval *span_domain) const
bool | IsArcAt (double t, const ON_Plane *plane=0, ON_Arc *arc=0, double tolerance=ON_ZERO_TOLERANCE, double *t0=0, double *t1=0) const
virtual bool | IsEllipse (const ON_Plane *plane=NULL, ON_Ellipse *ellipse=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsClosable (double tolerance, double min_abs_size=0.0, double min_rel_size=10.0) const
ON_3dPoint | PointAt (double t) const
ON_3dPoint | PointAtStart () const
ON_3dPoint | PointAtEnd () const
ON_3dVector | DerivativeAt (double t) const
ON_3dVector | TangentAt (double t) const
ON_3dVector | CurvatureAt (double t) const
ON_BOOL32 | FrameAt (double t, ON_Plane &plane) const
ON_BOOL32 | EvPoint (double t, ON_3dPoint &point, int side=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, int side=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, ON_3dVector &second_derivative, int side=0, int *hint=0) const
ON_BOOL32 | EvTangent (double t, ON_3dPoint &point, ON_3dVector &tangent, int side=0, int *hint=0) const
ON_BOOL32 | EvCurvature (double t, ON_3dPoint &point, ON_3dVector &tangent, ON_3dVector &kappa, int side=0, int *hint=0) const
bool | FirstSpanIsLinear (double min_length, double tolerance) const
bool | LastSpanIsLinear (double min_length, double tolerance) const
bool | FirstSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
bool | LastSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
virtual bool | Extend (const ON_Interval &domain)
ON_NurbsCurve * | NurbsCurve (ON_NurbsCurve *pNurbsCurve=NULL, double tolerance=0.0, const ON_Interval *subdomain=NULL) const
void | DestroyCurveTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Public Attributes

ON_U | m_edge_user
int | m_edge_index
int | m_c3i
int | m_vi [2]
ON_SimpleArray< int > | m_ti
double | m_tolerance

## Friends

class | ON_Brep

## Additional Inherited Members

Protected Member Functions inherited from ON_Curve
bool | ParameterSearch (double t, int &index, bool bEnableSnap, const ON_SimpleArray< double > &m_t, double RelTol=ON_SQRT_EPSILON) const

## Detailed Description

Definition at line 192 of file opennurbs_brep.h.

## Constructor & Destructor Documentation

ON_BrepEdge::ON_BrepEdge | ( |  | ) |

ON_BrepEdge::ON_BrepEdge | ( | int |  | ) |

## Member Function Documentation

ON_Brep* ON_BrepEdge::Brep | ( |  | ) | const

bool ON_BrepEdge::ChangeEdgeCurve | ( | int | c3i | ) |

ON_COMPONENT_INDEX ON_BrepEdge::ComponentIndex | ( |  | ) | const

virtual

Reimplemented from ON_Geometry.

ON__UINT32 ON_BrepEdge::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

void ON_BrepEdge::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

int ON_BrepEdge::EdgeCurveIndexOf | ( |  | ) | const

const ON_Curve* ON_BrepEdge::EdgeCurveOf | ( |  | ) | const

ON_BOOL32 ON_BrepEdge::IsClosed | ( |  | ) | const

virtual

Reimplemented from ON_Curve.

ON_BOOL32 ON_BrepEdge::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

ON::object_type ON_BrepEdge::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

ON_BrepEdge& ON_BrepEdge::operator= | ( | const ON_BrepEdge & |  | ) |

ON_BOOL32 ON_BrepEdge::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

ON_BOOL32 ON_BrepEdge::Reverse | ( |  | ) |

virtual

Implements ON_Curve.

ON_BOOL32 ON_BrepEdge::SetEndPoint | ( | ON_3dPoint | end_point | ) |

virtual

Reimplemented from ON_Curve.

ON_BOOL32 ON_BrepEdge::SetStartPoint | ( | ON_3dPoint | start_point | ) |

virtual

Reimplemented from ON_Curve.

unsigned int ON_BrepEdge::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

ON_BrepTrim* ON_BrepEdge::Trim | ( | int | eti | ) | const

int ON_BrepEdge::TrimCount | ( |  | ) | const

void ON_BrepEdge::UnsetPlineEdgeParameters | ( |  | ) |

ON_BrepVertex* ON_BrepEdge::Vertex | ( | int | evi | ) | const

ON_BOOL32 ON_BrepEdge::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Friends And Related Function Documentation

friend class ON_Brep

friend

Definition at line 378 of file opennurbs_brep.h.

## Member Data Documentation

int ON_BrepEdge::m_c3i

Definition at line 350 of file opennurbs_brep.h.

int ON_BrepEdge::m_edge_index

Definition at line 204 of file opennurbs_brep.h.

ON_U ON_BrepEdge::m_edge_user

Definition at line 201 of file opennurbs_brep.h.

ON_SimpleArray<int> ON_BrepEdge::m_ti

Definition at line 364 of file opennurbs_brep.h.

double ON_BrepEdge::m_tolerance

Definition at line 375 of file opennurbs_brep.h.

int ON_BrepEdge::m_vi[2]

Definition at line 361 of file opennurbs_brep.h.

The documentation for this class was generated from the following file:

- /build/pcl-0nnAvv/pcl-1.7.2/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_brep.h